/* ANCHOR: all */
# sdtool Usage Guide

[`sdtool`](https://github.com/BertoldVdb/sdtool) is a tool for locking the contents of a SD card by means of burning a physical fuse.

> It is relatively unknown that SD/MMC cards also have an electronic write protection system. Every card has two programmable flags, one for temporary write protection and one to lock the card forever. Writing these flags is not supported by most SD host devices. To remedy this, this page presents a program that allows a Linux host to configure the protection register.

This tool is also available via [stagex](https://registry.hub.docker.com/r/stagex/sdtool). The binary can be exported from the image by doing the following:

// ANCHOR: steps
* Get deterministically built binary of `sdtool` from StageX: 
  * `docker pull stagex/sdtool`

* Extracting binary:
  * Run docker container: `docker run -p 4000:80 --name sdtool stagex/sdtool`
    * This will error out the first time, run the command again and then you will get an error that's different that looks like this: `docker: Error response from daemon: Conflict. The container name "/sdtool" is already in use by container "679a52775dfce91f66d8894925449242eacbf4b0aeccaf2effe2c5e213e60a6b". You have to remove (or rename) that container to be able to reuse that name.`. Copy the container ID from the error message and use it in the next command
    * This issue occurs because of bin/sh missing in the image so we can't run the container properly
    * Copy image to tar: `docker export <container_id> -o sdtool.tar`
    * Extract binary from tar: `mkdir -p sdtool-dir | tar -xvf sdtool.tar -C sdtool-dir | cp sdtool-dir/usr/bin/sdtool ./sdtool`
    * You can verify the container hash:
        * To get container hash: `docker inspect --format='{{json .RepoDigests}}'  stagex/sdtool`
        * Check the [signatures dir](https://codeberg.org/stagex/stagex/src/branch/main/signatures/stagex) in stagex project for latest signed hashes

* `./sdtool /dev/mmcblk permlock`

* Test that the card can't be written to:

    * `dd if=out/airgap.iso of=/dev/sdb bs=1M conv=sync status=progress`

// ANCHOR_END: steps
/* ANCHOR_END: all */